diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
index 160c93803..030a7e430 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
@@ -1,71 +1,42 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLogicLayerBase;
 import net.minecraft.core.block.BlockLogicLayerLeaves;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.joml.Vector3d;
-import org.joml.primitives.AABBd;
 
-public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemBlock<T> {
+public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemBlockLayer<T> {
     public ItemBlockLayerLeaves(@NotNull Block<T> block) {
         super(block);
     }
 
-    // TODO: refactor to reuse ItemBlockLayer?
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
-        if (selfStack.stackSize <= 0) return false; 
-        if (tilePos.y() == world.getHeightBlocks() - 1 && this.block.getMaterial().isSolid()) {
-            return false;
-        }
-        final var targetBlock = world.getBlockType(tilePos);
-        if (targetBlock != this.block || side != Side.TOP) {
-            // you can no longer stack layers by placing on
-            // the top face of a partial block under the layers :3
-            return super.placeWithMeta(selfStack, world, player, tilePos, 
-                BlockLogicLayerLeaves.setPermanent(0, true), side, xHit, yHit);
-        }
-
-        final @NotNull BlockLogicLayerBase blockLayer = this.block.getLogic();
-        final int meta = world.getBlockData(tilePos) + 1;
-
-        final var bbmin = new Vector3d(tilePos.vec());
-        final var bbmax = new Vector3d(bbmin).add(1, (meta + 1) / 8.0f, 1);
-        if (!world.checkIfAABBIsClear(new AABBd(bbmin, bbmax))) return false;
-
-        final boolean placed;
-        final @NotNull Block<?> placedBlock;
-        final var placedPos = new TilePos(tilePos);
+    public boolean canAccumulateInto(
+        @NotNull ItemStack selfStack,
+        @NotNull Block<?> block, int data, @NotNull Side side, double xHit, double yHit
+    ) {
+        return block == this.block && !(yHit - (((data&0xF) + 1) * 0.125) <= -0x1p-12);
+    }
 
-        if ((meta & 0x0F) < 7) {
-            placedBlock = this.block;
-            placed = world.setBlockTypeData(placedPos, placedBlock, BlockLogicLayerLeaves.setPermanent(meta, true));
-        } else if (blockLayer.fullBlock != null) {
-            placedBlock = blockLayer.fullBlock;
-            placed = world.setBlockTypeData(placedPos, placedBlock, BlockLogicLayerLeaves.setPermanent(0, true));
+    @Override
+    public @NotNull BlockDataResult getAccumulationResult(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos,
+        @NotNull Side side, double xHit, double yHit,
+        @NotNull BlockDataResult result
+    ) {
+        result.data |= BlockLogicLayerLeaves.MASK_PERMANENT;
+        if ((result.data & 0xF) < 6) {
+            result.data += 1;
         } else {
-            placedBlock = this.block;
-            // TODO this can place inside entities
-            placed = world.setBlockTypeData(placedPos.up(), placedBlock, BlockLogicLayerLeaves.setPermanent(0, true));
+            result.block = this.block.getLogic().fullBlock;
+            result.data &= ~0xF;
         }
-        if (!placed) return false;
-        selfStack.consumeItem(player);
-
-        placedBlock.onPlacedByMob(world, tilePos, side, player, xHit, yHit);
-        world.notifyBlockChange(placedPos, placedBlock);
-
-        world.playBlockSoundEffect(player,
-            placedPos.x() + 0.5F, placedPos.y() + 0.5F, placedPos.z() + 0.5F,
-            this.block, EnumBlockSoundEffectType.PLACE);
-        return true;
+        return result;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
index 6075de3e5..953a53c21 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
@@ -2,73 +2,55 @@ package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
-import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.item.IAccumulatable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.joml.Vector3d;
-import org.joml.primitives.AABBd;
 
-public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T> {
+public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T>
+    implements IAccumulatable<T>
+{
     public ItemBlockSlab(@NotNull Block<T> block) {
         super(block);
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        if (selfStack.stackSize <= 0) return false;
-        if (blockPos.y() == world.getHeightBlocks() - 1 && this.block.getMaterial().isSolid()) {
-            return false;
-        }
-
-        var block = world.getBlockType(blockPos);
-        if (block.hasTag(BlockTags.PLACE_OVERWRITES)) {
-            return super.onUseOnBlock(selfStack, world, player, blockPos, side, xHit, yHit);
-        }
-
-        final int selfMeta = selfStack.getMetadata();
-        final var shiftPos = new TilePos(blockPos);
-        
-        int i;
-        for (i = 0; i < 2; i++) {
-            block = world.getBlockType(shiftPos);
-            final var blockMeta = world.getBlockData(shiftPos);
-            final boolean canPlaceInto =
-                block == this.block &&
-                    (blockMeta & ~0b11) == selfMeta &&
-                    switch (blockMeta & 0b11) {
-                        default -> false;
-                        case 0 -> yHit >= 0.5f;
-                        case 2 -> yHit <= 0.5f;
-                    };
-            if (canPlaceInto) break;
-            shiftPos.add(side);
-            yHit -= side.offsetY();
-        } if (i == 2) { // for else
-            return super.onUseOnBlock(selfStack, world, player, blockPos, side, xHit, yHit);
-        }
-
-        final var bbmin = new Vector3d(shiftPos.vec());
-        final var bbmax = new Vector3d(bbmin).add(1,1,1);
-        if (!world.checkIfAABBIsClear(new AABBd(bbmin, bbmax))) return false;
-
-        if (!world.setBlockData(shiftPos, 1 | selfStack.getMetadata())) return false;
-        selfStack.consumeItem(player);
+    public boolean canAccumulateInto(
+        @NotNull ItemStack selfStack,
+        @NotNull Block<?> block, int data, @NotNull Side side, double xHit, double yHit
+    ) {
+        return this.block == block && (data & ~0b11) == selfStack.getMetadata() &&
+            switch (data & 0b11) {
+                default -> false;
+                case 0 -> !(yHit - 0.5f <= -0x1p-12);
+                case 2 -> !(yHit - 0.5f >= +0x1p-12);
+            };
+    }
 
-        // this invokes modelBlock's on place logic. is this a good idea?
-        this.block.onPlacedByWorld(world, shiftPos);
+    @Override
+    public @NotNull BlockDataResult getAccumulationResult(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos,
+        @NotNull Side side, double xHit, double yHit,
+        @NotNull BlockDataResult result
+    ) {
+        result.data = 1 | selfStack.getMetadata();
+        result.bounds.setMin(0,0,0).setMax(1,1,1);
+        return result;
+    }
 
-        world.notifyBlockChange(shiftPos, block);
-        world.playBlockSoundEffect(player,
-            shiftPos.x() + 0.5F, shiftPos.y() + 0.5F, shiftPos.z() + 0.5F,
-            this.block, EnumBlockSoundEffectType.PLACE);
-        
-        return true;
+    @Override
+    public void postAccumulate(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos,
+        @NotNull Side side, double xHit, double yHit,
+        @NotNull BlockDataResult result
+    ) {
+        this.block.onPlacedByWorld(world, tilePos);
     }
-}
\ No newline at end of file
+}
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java b/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java
index 8dc5e25ad..53766556e 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java
@@ -17,7 +17,7 @@ import static net.minecraft.core.player.inventory.menu.MenuInventoryCreative.CRE
 import static net.minecraft.core.player.inventory.menu.MenuInventoryCreative.CREATIVE_PAGE_SIZE;
 
 public final class CreativeMenuContents {
-	public static boolean ADD_GAPS = false; // Disabled for now, need to discuss full creative gui rework for 8.1
+	public static boolean ADD_GAPS = true; // Disabled for now, need to discuss full creative gui rework for 8.1
 
 	private static final DyeColor[] RAINBOW_ORDER = {
 		DyeColor.RED,
@@ -90,6 +90,8 @@ public final class CreativeMenuContents {
 
 		addLogTypes(list);
 		newLine(list);
+		addWorkstationsAndGlass(list);
+		newLine(list);
 		addWoodTypes(list);
 		newPage(list);
 
@@ -98,9 +100,6 @@ public final class CreativeMenuContents {
 		addOrganicTypes(list);
 		newPage(list);
 
-		addWorkstationsAndGlass(list);
-		newPage(list);
-
 		addTools(list);
 		newPage(list);
 
@@ -180,6 +179,9 @@ public final class CreativeMenuContents {
 
 		list.add(new ItemStack(Items.TOOL_SHEARS));
 		list.add(new ItemStack(Items.TOOL_SHEARS_STEEL));
+
+		list.add(new ItemStack(Items.MAP));
+		list.add(new ItemStack(Items.LABEL));
 		newLine(list);
 
 		addBucketVariants(list, Items.BUCKET_IRON);
@@ -191,25 +193,23 @@ public final class CreativeMenuContents {
 		list.add(new ItemStack(Items.WAND_MONSTER_SPAWNER));
 		list.add(new ItemStack(Items.WAND_NBT));
 		list.add(new ItemStack(Items.TOOL_FISHINGROD));
+		addGap(list, 1);
+		list.add(new ItemStack(Items.TOOL_COMPASS));
 		newLine(list);
 
 		list.add(new ItemStack(Items.TOOL_BOW));
 		list.add(new ItemStack(Items.AMMO_ARROW));
 		list.add(new ItemStack(Items.AMMO_ARROW_GOLD));
 		list.add(new ItemStack(Items.AMMO_ARROW_FLAMING));
+		addGap(list, 1);
+		list.add(new ItemStack(Items.TOOL_CLOCK));
 		newLine(list);
 
 		list.add(new ItemStack(Items.HANDCANNON_UNLOADED));
 		list.add(new ItemStack(Items.AMMO_CHARGE_EXPLOSIVE));
 		list.add(new ItemStack(Items.AMMO_FIREBALL));
-		newLine(list);
-
-		list.add(new ItemStack(Items.TOOL_COMPASS));
-		list.add(new ItemStack(Items.TOOL_CLOCK));
+		addGap(list, 2);
 		list.add(new ItemStack(Items.TOOL_CALENDAR));
-		list.add(new ItemStack(Items.MAP));
-		list.add(new ItemStack(Items.ROPE));
-		list.add(new ItemStack(Items.LABEL));
 		newLine(list);
 	}
 
@@ -236,8 +236,21 @@ public final class CreativeMenuContents {
 		addBlock(list, Blocks.BUTTON_STONE);
 		addBlock(list, Blocks.PRESSURE_PLATE_STONE);
 		addBlock(list, Blocks.PRESSURE_PLATE_COBBLE_STONE);
+		newLine(list);
+
+		addBlock(list, Blocks.SLATE);
+		addBlock(list, Blocks.LAYER_SLATE);
+
+		addBlock(list, Blocks.BRICK_SLATE);
+		addBlock(list, Blocks.STAIRS_BRICK_SLATE);
+		addBlock(list, Blocks.SLAB_BRICK_SLATE);
+
+		addBlock(list, Blocks.SLATE_POLISHED);
+		addBlock(list, Blocks.SLAB_SLATE_POLISHED);
+		list.add(new ItemStack(Items.STATUE_SLATE));
 		newPage(list);
 
+
 		addBlock(list, Blocks.BASALT);
 		addBlock(list, Blocks.MOSS_BASALT);
 
@@ -256,7 +269,7 @@ public final class CreativeMenuContents {
 		addBlock(list, Blocks.BUTTON_BASALT);
 		addBlock(list, Blocks.PRESSURE_PLATE_BASALT);
 		addBlock(list, Blocks.PRESSURE_PLATE_COBBLE_BASALT);
-		newPage(list);
+		newLine(list);
 
 		addBlock(list, Blocks.LIMESTONE);
 		addBlock(list, Blocks.MOSS_LIMESTONE);
@@ -296,7 +309,7 @@ public final class CreativeMenuContents {
 		addBlock(list, Blocks.BUTTON_GRANITE);
 		addBlock(list, Blocks.PRESSURE_PLATE_GRANITE);
 		addBlock(list, Blocks.PRESSURE_PLATE_COBBLE_GRANITE);
-		newPage(list);
+		newLine(list);
 
 		addBlock(list, Blocks.PERMAFROST);
 
@@ -333,7 +346,7 @@ public final class CreativeMenuContents {
 		addBlock(list, Blocks.BUTTON_NETHERRACK);
 		addBlock(list, Blocks.PRESSURE_PLATE_NETHERRACK);
 		addBlock(list, Blocks.PRESSURE_PLATE_COBBLE_NETHERRACK);
-		newPage(list);
+		newLine(list);
 
 		addBlock(list, Blocks.GLOOMSTONE);
 
@@ -371,7 +384,7 @@ public final class CreativeMenuContents {
 		addBlock(list, Blocks.SLAB_BRICK_BRIMSTONE);
 		addBlock(list, Blocks.BUTTON_BRIMSTONE);
 		addBlock(list, Blocks.PRESSURE_PLATE_BRIMSTONE);
-		newPage(list);
+		newLine(list);
 
 		addBlock(list, Blocks.MARBLE);
 
@@ -384,18 +397,8 @@ public final class CreativeMenuContents {
 		addBlock(list, Blocks.SLAB_CAPSTONE_MARBLE);
 		list.add(new ItemStack(Items.STATUE_MARBLE));
 		list.add(new ItemStack(Items.STATUE_PIGMAN));
-		newLine(list);
-
-		addBlock(list, Blocks.SLATE);
-		addBlock(list, Blocks.LAYER_SLATE);
 
-		addBlock(list, Blocks.BRICK_SLATE);
-		addBlock(list, Blocks.STAIRS_BRICK_SLATE);
-		addBlock(list, Blocks.SLAB_BRICK_SLATE);
 
-		addBlock(list, Blocks.SLATE_POLISHED);
-		addBlock(list, Blocks.SLAB_SLATE_POLISHED);
-		list.add(new ItemStack(Items.STATUE_SLATE));
 		newPage(list);
 	}
 
@@ -409,7 +412,6 @@ public final class CreativeMenuContents {
 		addBlock(list, Blocks.LOG_THORN);
 		addBlock(list, Blocks.LOG_PALM);
 		addBlock(list, Blocks.LOG_SCORCHED);
-		newPage(list);
 	}
 
 	private static void addWoodTypes(List<ItemStack> list) {
@@ -451,7 +453,7 @@ public final class CreativeMenuContents {
 		list.add(new ItemStack(Items.SIGN_PAINTED, 1, color.itemMeta));
 	}
 
-	private static void addPaintedWoodBlock(List<ItemStack> list, Block<?> block, DyeColor color) {
+	private static void addPaintedWoodBlock(@NotNull List<ItemStack> list, Block<?> block, DyeColor color) {
 		list.add(new ItemStack(block, 1, painted(block).toMetadata(color)));
 	}
 
@@ -864,6 +866,7 @@ public final class CreativeMenuContents {
 		addBlock(list, Blocks.FENCE_STEEL);
 
 		list.add(new ItemStack(Items.PAINTING));
+		list.add(new ItemStack(Items.ROPE));
 		newLine(list);
 
 		list.add(new ItemStack(Items.DOOR_GLASS));
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java b/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java
index 2ad48ff04..e4d61e392 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java
@@ -210,6 +210,20 @@ public enum Direction {
         }
     }
 
+    public static @NotNull double[] YAW_MAP = new double[6];
+    static {
+        for (int i = 0; i < 4; i++) {
+            final double yaw = i * 90D;
+            final var dir = Direction.fromYaw(yaw);
+            YAW_MAP[dir.id] = yaw;
+        }
+        YAW_MAP[UP.id] = YAW_MAP[DOWN.id] = Double.NaN;
+    }
+
+    public double yaw() {
+        return YAW_MAP[this.id];
+    }
+
     /**
      * Right-handed around the +X axis
      */
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 27a143f3f..5546e3925 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -2986,18 +2986,21 @@ public abstract class World implements MutableWorldSource {
         return this.dimensionData.getWorldType();
     }
 
-    public @NotNull EntityItem dropItem(final @NotNull TilePosc tilePos, final @NotNull ItemStack itemStack) {
-        final float radius = 0.7f;
-        final double x = (this.rand.nextFloat() * radius) + (1.0F - radius) * 0.5D;
-        final double y = (this.rand.nextFloat() * radius) + (1.0F - radius) * 0.5D;
-        final double z = (this.rand.nextFloat() * radius) + (1.0F - radius) * 0.5D;
+    public @NotNull EntityItem dropItem(double x, double y, double z, final @NotNull ItemStack itemStack, double radius) {
+        x += this.rand.nextFloat() * radius;
+        y += this.rand.nextFloat() * radius;
+        z += this.rand.nextFloat() * radius;
 
-        final @NotNull EntityItem item = new EntityItem(this, tilePos.x() + x, tilePos.y() + y, tilePos.z() + z, itemStack);
+        final @NotNull EntityItem item = new EntityItem(this, x, y, z, itemStack);
         item.pickupDelay = 10;
         this.entityJoinedWorld(item);
         return item;
     }
 
+    public @NotNull EntityItem dropItem(final @NotNull TilePosc tilePos, final @NotNull ItemStack itemStack) {
+        return this.dropItem(tilePos.x(), tilePos.y(), tilePos.z(), itemStack, 0.7);
+    }
+
     @Deprecated
     public final @NotNull EntityItem dropItem(final int x, final int y, final int z, final @NotNull ItemStack itemStack) {
         return this.dropItem(new TilePos(x, y, z), itemStack);
